// Xlib.h also defines True/False
#define GFX_NO_BOOL_MACROS

#include <stdio.h>
#include <gfx/std.h>
#include <gfx/GL/gl.h>
#include <gfx/GL/Camera.h>

void glCamera::glApply(GLenum mode)
{
    GLint last_mode; glGetIntegerv(GL_MATRIX_MODE, &last_mode);
      glMatrixMode(mode);
      glApply();
    glMatrixMode((GLenum)last_mode);
}

void glCamera::glApply()
{
    gluPerspective(fovy, aspect, znear, zfar);
    gluLookAt(from[X], from[Y], from[Z],
	      at[X], at[Y], at[Z],
	      up[X], up[Y], up[Z]);
}

//void glCamera::lookAt(const Vec3& min, const Vec3& max, const Vec3& center)
void glCamera::lookAt(const Bounds& bounds, double ratio)
{

    double d = 3*bounds.radius / tan(60*M_PI/180.0);

    at = bounds.center;
    from = at;

    from[Z] += d;

    up[X] = 0; up[Y] = 1; up[Z] = 0;

    fovy = 60.0;
    aspect = ratio;

    znear = d/20;
    zfar = 10*d;
}
