#include <gfx/std.h>
#include <gfx/XF/glxf.h>

void glxf_make_current(FL_OBJECT *canvas)
{
    static FL_OBJECT *current = NULL;

    if( canvas!=current )
    {
	GLXContext ctx = fl_get_glcanvas_context(canvas);
	Window win = fl_get_canvas_id(canvas);

	glXMakeCurrent(fl_display, win, ctx);
	current = canvas;
    }
}

void glxf_finish(FL_OBJECT *canvas)
{
    glXSwapBuffers(fl_display, fl_get_canvas_id(canvas));
}

int GLXF_CFG_DOUBLEBUFFER[] =
{
    GLX_DOUBLEBUFFER,
    GLX_RGBA,
    GLX_RED_SIZE, 1,
    GLX_GREEN_SIZE, 1,
    GLX_BLUE_SIZE, 1,
    GLX_DEPTH_SIZE, 1,
    None
};

int GLXF_CFG_SINGLEBUFFER[] =
{
    GLX_RGBA,
    GLX_RED_SIZE, 1,
    GLX_GREEN_SIZE, 1,
    GLX_BLUE_SIZE, 1,
    GLX_DEPTH_SIZE, 1,
    None
};

void glxf_set_defaults(int *cfg)
{
    fl_set_glcanvas_defaults(cfg);
}
