#ifndef GFXMANIP_ARCBALL_INCLUDED // -*- C++ -*-
#define GFXMANIP_ARCBALL_INCLUDED

//
// Include the interface file for the actual Arcball code
//
#include <gfx/manip/arcball/Arcball.h>

#include <gfx/manip/base.h>
#include <gfx/geom/3D.h>

class Arcball : public Manipulator
{
    HVect vNow;
    int mousex, mousey;
    int startx, starty;
    BallData *ball;
    Quat center;
    float radius;

    float camx, camy, camz;

    enum {NoDrag=0, Spin, Dolly, Zoom} dragging;

public:
    Arcball() { }
    Arcball(const Bounds& bounds, float aspect) { init(bounds,aspect); }
    void init(const Bounds& bounds, float aspect);

    int mouse_down(int button, int state, int x, int y);
    int mouse_up(int button, int state, int x, int y);
    int motion(int x, int y);

    void apply();
    void unapply();
    void draw();
};

// GFXMANIP_ARCBALL_INCLUDED
#endif
